;##########################################################################################################
; SysButton (2009-05-31)
; by kero <geocities.com/xmemor>
; (tested on Win XP-pro-sp2)
;##########################################################################################################

; ml /c /coff /I\masm32\include SysButton.asm
; link /subsystem:windows /LIBPATH:\masm32\lib SysButton.obj

.386
.model flat,stdcall  ; 'ml /Gz' = 'stdcall'
option casemap:none  ; 'ml /Cp'
        
inclib macro x
 include x.inc
 includelib x.lib
endm

include windows.inc
inclib user32
inclib kernel32
inclib gdi32
inclib comctl32
;inclib uxtheme

.const
 STAP_ALLOW_NONCLIENT  equ 1
 STAP_ALLOW_CONTROLS   equ 2
 STAP_ALLOW_WEBCONTENT equ 4
 WM_THEMECHANGED       equ 031Ah
 id    equ  100

.data
 _txt   db "MSDN  - ""WM_NCHITTEST Notification"":",13,10
        db "   ""HTSYSMENU  in a window menu or in a CLOSE button in a CHILD window.""",13,10,13,10
        db "But why CHILD, CLOSE, HTSYSMENU namely?",13,10
        db "Let's build some window captions just now.",13,10,13,10
        db "Mouse  and  #1...#8  windows:",13,10
        db " 1.  L-button:  Move.",13,10
        db " 2.  R-:  Resize  (but sm_cxmintrack limit).",13,10
        db " 3.  M-:  +/- THEME  trigger.",13,10
        db " 4.  L-2-click:  POPUP/CHILD  trigger.",13,10
        db " 5.  Wheel + Focus + cursor",13,10
        db "     over window:  CAPTION  toggle;",13,10
        db "     outside window:  RESIZE.",13,10,13,10
        db "QUIT:  from MDI menu.",13,10,13,10
        db " SysButton  by kero,  2009-05-31.",0
 _q     db "?",0
 _qq    db "??",0 
 _mdi   db "MDIClient",0
 _UT    db "UxTheme",0
 _ITA   db "IsThemeActive",0
 _STAP  db "SetThemeAppProperties",0
 _GTAP  db "GetThemeAppProperties",0
 _ft    db "#%d",0
 menu_  dw 0,0,80h,0,'#','1',0
 lf     LOGFONT <-11,0,0,0,400,0,0,0,1,0,0,0,0,"Tahoma">

.data?
 hicon  dd ?
 hmenu  HMENU ?
 hfont  HFONT ?

.code

;##########################################################################################################

ThemeApp proc uses ebx hWnd:HWND
  invoke GetModuleHandle,offset _UT
  mov ebx,eax
  .if eax!=NULL
    invoke GetProcAddress,ebx,offset _ITA
    call eax
    .if eax==TRUE
      invoke GetProcAddress,ebx,offset _GTAP
      call eax
      .if eax!=0
        xor eax,eax
      .else
        mov eax,STAP_ALLOW_NONCLIENT or STAP_ALLOW_CONTROLS or STAP_ALLOW_WEBCONTENT
      .endif
      push eax
      invoke GetProcAddress,ebx,offset _STAP
      call eax
      invoke SendMessage,hWnd,WM_THEMECHANGED,0,0
      invoke SetWindowPos,hWnd,0,0,0,0,0,SWP_NOZORDER or SWP_NOMOVE or SWP_NOSIZE or SWP_FRAMECHANGED or SWP_NOACTIVATE
    .endif
  .endif
  ret
ThemeApp endp

;##########################################################################################################

MdiRepair proc uses ebx edi hWnd:HWND

  invoke GetWindow,hWnd,GW_CHILD
  .if eax!=0
    mov ebx,eax
    invoke GetWindowLong,ebx,GWL_USERDATA
    mov edi,eax    
    invoke GetWindowLong,hWnd,GWL_USERDATA
    .if eax==0 && edi==0
      invoke SetFocus,ebx
    .endif
  .endif
  invoke InvalidateRect,hWnd,0,1
  mov eax,ebx
  ret
MdiRepair endp

;##########################################################################################################

WindowCaption proc uses ebx edi esi hWnd:HWND,lParam:LPARAM
  local buf[16]:BYTE
  invoke GetWindowLong,hWnd,GWL_USERDATA
  mov esi,eax
  add esi,lParam
  mov ebx,WS_POPUP or WS_VISIBLE or WS_SYSMENU or WS_CAPTION
  .if esi==0 || esi==8
    mov esi,0
    mov edi,hicon
    mov ebx,WS_POPUP or WS_VISIBLE or WS_SYSMENU
    mov ecx,WS_EX_CLIENTEDGE or WS_EX_DLGMODALFRAME
  .elseif esi==1
    mov edi,hicon
    mov ebx,WS_POPUP or WS_VISIBLE or WS_SYSMENU or WS_CAPTION or WS_MINIMIZEBOX or WS_MAXIMIZEBOX
    mov ecx,WS_EX_CLIENTEDGE
  .elseif esi==2
    mov edi,0
    mov ebx,WS_POPUP or WS_VISIBLE or WS_SYSMENU or WS_CAPTION or WS_MINIMIZEBOX or WS_MAXIMIZEBOX
    mov ecx,WS_EX_CLIENTEDGE or WS_EX_DLGMODALFRAME
  .elseif esi==3
    mov edi,hicon
    mov ecx,WS_EX_CLIENTEDGE or WS_EX_CONTEXTHELP
  .elseif esi==4
    mov edi,0
    mov ecx,WS_EX_CLIENTEDGE or WS_EX_CONTEXTHELP or WS_EX_DLGMODALFRAME
  .elseif esi==5
    mov edi,hicon
    mov ecx,WS_EX_CLIENTEDGE
  .elseif esi==6
    mov edi,0
    mov ecx,WS_EX_CLIENTEDGE or WS_EX_DLGMODALFRAME
  .elseif esi==7 || esi==-1
    mov esi,7
    mov edi,hicon
    mov ecx,WS_EX_CLIENTEDGE or WS_EX_TOOLWINDOW
  .endif
  invoke SetWindowLong,hWnd,GWL_EXSTYLE,ecx
  invoke SetWindowLong,hWnd,GWL_STYLE,ebx
  .if esi==0
    mov eax,hmenu
  .else
   xor eax,eax
 .endif
  invoke SetMenu,hWnd,eax
  invoke SendMessage,hWnd,WM_SETICON,ICON_BIG,edi
  invoke SetWindowLong,hWnd,GWL_USERDATA,esi
  invoke SetWindowPos,hWnd,0,0,0,0,0,SWP_NOZORDER or SWP_NOSIZE or SWP_NOMOVE or SWP_FRAMECHANGED
  inc esi
  invoke wsprintf,addr buf,offset _ft,esi
  invoke SetWindowText,hWnd,addr buf
  ret
WindowCaption endp

;##########################################################################################################

MouseWheel proc hWnd:HWND,wParam:WPARAM,lParam:LPARAM
  local rt:RECT
  invoke GetWindowRect,hWnd,addr rt
  mov eax,lParam
  mov edx,eax
  and eax,0ffffh       ; x
  shr edx,16           ; y    
  xor ecx,ecx
  cmp eax,rt.left      
  jl @f
  or ecx,1h
@@:
  cmp eax,rt.right     
  jge @f
  or ecx,2h
@@:
  cmp edx,rt.top       
  jl @f
  or ecx,4h
@@:
  cmp edx,rt.bottom    
  jge @f
  or ecx,8h
@@:
  xor edx,edx
  .if wParam<80000000h
    inc edx            ; +1
  .else                
    dec edx            ; -1
  .endif
  mov eax,rt.left
  sub rt.right,eax
  mov eax,rt.top
  sub rt.bottom,eax
  .if ecx==0Fh
    mov eax,edx
  .else
    mov eax,ecx
    and eax,3h
    .if eax!=3h
      mov eax,rt.right
      add eax,edx
      .if eax==0
        mov eax,4
      .endif
      mov rt.right,eax
    .endif
    mov eax,ecx
    and eax,0Ch
    .if eax!=0Ch
      mov eax,rt.bottom
      add eax,edx
      .if eax==0
        mov eax,4
      .endif
      mov rt.bottom,eax
    .endif
    invoke SetWindowPos,hWnd,0,0,0,rt.right,rt.bottom,SWP_NOZORDER or SWP_NOMOVE or SWP_FRAMECHANGED or SWP_NOACTIVATE
    xor eax,eax
  .endif
  ret
MouseWheel endp

;##########################################################################################################

PopupChild proc hWnd:HWND

  invoke GetWindowLong,hWnd,GWL_STYLE
  mov ecx,eax
  and ecx,WS_POPUP
  .if ecx!=0
    and eax,not WS_POPUP
    or eax,WS_CHILD
  .else
    and eax,not WS_CHILD
    or eax,WS_POPUP
  .endif
  invoke SetWindowLong,hWnd,GWL_STYLE,eax
  invoke SetWindowPos,hWnd,0,0,0,0,0,SWP_NOZORDER or SWP_NOSIZE or SWP_NOMOVE or SWP_FRAMECHANGED ; or SWP_NOACTIVATE
  ret
PopupChild endp

;##########################################################################################################

OnPaint proc uses ebx hWnd:HWND

  local ps:PAINTSTRUCT
  local rt:RECT

  invoke GetClientRect,hWnd, addr rt
  add rt.left,10
  add rt.top,8
  invoke BeginPaint,hWnd,addr ps
  mov ebx,eax
;  invoke GetStockObject,DEFAULT_GUI_FONT
  mov eax,hfont
  invoke SelectObject,ebx,eax
  push eax
;  invoke SetBkMode,ebx,TRANSPARENT
;  invoke SetTextColor,ebx,Black
  invoke DrawText,ebx,offset _txt,-1,addr rt,DT_EDITCONTROL or DT_LEFT or DT_TOP or DT_WORDBREAK or DT_WORD_ELLIPSIS ; or DT_END_ELLIPSIS or DT_MODIFYSTRING or DT_PATH_ELLIPSIS
  pop eax
  invoke SelectObject,ebx,eax    
  invoke EndPaint,hWnd,addr ps
  ret
OnPaint endp

;##########################################################################################################

WndProc proc hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM

  mov eax,uMsg
  mov ecx,wParam

  .if eax==WM_DESTROY
    invoke PostQuitMessage,0

  .elseif eax==WM_COMMAND && ecx==SC_CLOSE  ; close app from MDI menu
    invoke DestroyWindow,hWnd

  .elseif eax==WM_SYSCOMMAND && (ecx==SC_MINIMIZE || ecx==SC_MAXIMIZE || ecx==SC_CLOSE)

  .elseif eax==WM_CREATE
    xor eax,eax
    jmp @f

  .elseif eax==WM_MOUSEWHEEL
    invoke MouseWheel,hWnd,ecx,lParam  ; reSIZE / reCAPTION
    .if eax!=0
@@:
      invoke WindowCaption,hWnd,eax  ; reCAPTION
      jmp @f
    .endif

  .elseif eax==WM_SIZE
@@:
    invoke MdiRepair,hWnd

  .elseif eax==WM_PAINT
    invoke OnPaint,hWnd

  .elseif eax==WM_LBUTTONDBLCLK  ; Popup/Child trigger
    invoke PopupChild,hWnd

  .elseif eax==WM_MBUTTONDOWN  ; +/-Themed trigger
    invoke ThemeApp,hWnd

  .elseif eax==WM_RBUTTONDOWN  ; Size
    mov ecx,SC_SIZE or 8
    jmp @f

  .elseif eax==WM_LBUTTONDOWN  ; Move
    mov ecx,SC_SIZE or 9
@@:
    mov eax,WM_SYSCOMMAND
    jmp @f
  .else
@@:
    invoke DefWindowProc,hWnd,eax,ecx,lParam
    jmp @f
  .endif
  xor eax,eax
@@:
  ret
WndProc endp

;##########################################################################################################

Main proc uses ebx hInst:HINSTANCE

  local clientcreate:CLIENTCREATESTRUCT
  local mdicreate:MDICREATESTRUCT
  local wc:WNDCLASSEX
  local msg:MSG

  invoke CreateFontIndirect,offset lf
  mov hfont,eax

  invoke LoadMenuIndirect,offset menu_
  mov hmenu,eax
  invoke GetSubMenu,eax,1
  mov clientcreate.hWindowMenu,eax
  mov clientcreate.idFirstChild,0

  mov eax,hInst
  mov mdicreate.hOwner,eax
  mov mdicreate.style,WS_MAXIMIZE
  mov mdicreate.szTitle,0  
  mov mdicreate.szClass,offset _qq

  mov wc.cbSize,sizeof wc
  mov wc.hInstance,eax  
  mov wc.style,CS_DBLCLKS
  mov wc.cbClsExtra,0
  mov wc.cbWndExtra,0
  mov wc.hbrBackground,COLOR_WINDOW+1
  mov wc.lpszMenuName,0
  xor eax,eax
  mov wc.hIcon,eax
  mov wc.hIconSm,eax
  invoke LoadCursor,0,IDC_HAND
  mov wc.hCursor,eax
  mov wc.lpfnWndProc,offset WndProc
  mov wc.lpszClassName,offset _q
  invoke RegisterClassEx,addr wc

  invoke LoadIcon,0,IDI_QUESTION
  mov hicon,eax

  mov wc.hIcon,eax
  mov wc.hIconSm,eax
  mov wc.lpfnWndProc,DefWindowProc  ; DefMDIChildProc
  mov wc.lpszClassName,offset _qq
  invoke RegisterClassEx,addr wc

  invoke CreateWindowEx,WS_EX_TOPMOST,offset _qq,0,WS_POPUP,0,0,0,0,0,0,hInst,0
  invoke CreateWindowEx,0,offset _q,0,WS_POPUP,20,20,410,290,eax,0,hInst,0
  mov ebx,eax
  invoke CreateWindowEx,0,offset _q,0,WS_CHILD,240,120,130,80,ebx,0,hInst,0
  invoke CreateWindowEx,0,offset _mdi,0,WS_CHILD,0,0,0,0,ebx,0,hInst,addr clientcreate
  mov ecx,eax
  invoke SendMessage,ecx,WM_MDICREATE,0,addr mdicreate

  .while TRUE
    invoke GetMessage,addr msg,0,0,0
    .break .if (!eax)
    invoke TranslateMessage,addr msg
    invoke DispatchMessage,addr msg
  .endw

  invoke DeleteObject,hfont
  invoke DestroyMenu,hmenu
  mov eax,msg.wParam
  ret
Main endp

;##########################################################################################################

start:
  invoke GetModuleHandle,0
  invoke Main,eax
  invoke ExitProcess,eax
  invoke InitCommonControls
end start

;##########################################################################################################
